function [label,centers,sumD,Ds] = spclustering(X,k,stream)
%Spectral clustering for purpose of MSC
%Copyright@Juhua Hu, Aug 10, 2017
[ins,~] = size(X);
S = squareform(pdist(X));
meanD = sum(sum(S))/(ins*(ins-1));
S = exp(-S.^2./(2*meanD^2))-eye(ins,ins);
d = sum(S,2);
DD = 1./sqrt(d);
normD = DD*DD';
SS = S.*normD;
[V,D] = eig((SS+SS')./2);
dvalue = diag(D);
[~,ind] = sort(dvalue,'descend');
V = V(:,ind);
newX = V(:,1:k);
for j=1:size(newX,1)
    if norm(newX(j,:))>0
    newX(j,:) = newX(j,:)./norm(newX(j,:));
    end
end
reset(stream);
[label, centers,sumD,Ds] = kmeans(newX,k,'replicates',10); 
end